
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>
#include <time.h>

#include "frcmpr.h"


extern PAR_COMPR   par_cmp;
extern LIST        *lst;
extern CONTORNO    *cont;
extern BYTE        *image, *image2;
extern int         img_size_x, img_size_y;
extern int         zoom, nbox, xxx;



/*******************/
sub_div_4( int col1, int col2, int x1, int y1, int x2, int y2 )    
/*******************/
{
int    dx=(x1+x2)/2, dy=(y1+y2)/2;

show_add_box( col1, col2, x1, y1, dx, dy );
show_add_box( col1, col2, x1, dy+1, dx, y2 );
show_add_box( col1, col2, dx+1, y1, x2, dy );
show_add_box( col1, col2, dx+1, dy+1, x2, y2 );
}


/*******************/
sub_div_2( int col1, int col2, int x1, int y1, int x2, int y2 )    
/*******************/
{
int    xm=(x1+x2)/2, ym=(y1+y2)/2;

if( (x2-x1) > (y2-y1) ) {      /* split horz... */
   show_add_box( col1, col2, x1, y1, xm, y2 );
   show_add_box( col1, col2, xm+1, y1, x2, y2 );
   }
else {                 /* split vert... */
   show_add_box( col1, col2, x1, y1, x2, ym );
   show_add_box( col1, col2, x1, ym+1, x2, y2 );
   }
}



/*******************/
sub_div_2_new( int col1, int col2, int x1, int y1, int x2, int y2 )    
/*******************/
{
int    i, j, l=x2, r=x1, u=y2, d=y1, sy=1, dir, lmin;
int    xw, yw, bestxm, bestym, xm=(x1+x2)/2, ym=(y1+y2)/2;

for( i=y1;   i <= y2;   i++ )      /* analizza i contorni... */
   for( j=x1;   j <= x2;   j++ )
       if( IMG2( j, i ) ) {
           if( l > j) l = j;
           if( r < j) r = j;
           if( sy ) { sy = 0; u = i; }
           d = i;
           }

l = min( x2, l+0 );  r = max( l, r-0 );
u = min( y2, u+0 );  d = max( u, d-0 ); 
bestxm = abs( xm - l) < abs( xm - r) ? l : r;
bestym = abs( ym - u) < abs( ym - d) ? u : d;
xw = min( abs(bestxm-x1), abs(bestxm-x2) );
yw = min( abs(bestym-y1), abs(bestym-y2) );

dir = max( xw, yw );               /* modifica 22/8/93: per avere */
lmin = min( x2-x1, y2-y1 );        /* box abbastanza regolari... */

if( max( xw, yw ) < 2  ||  dir < lmin / 4 )    /* dividi a meta'... */
   sub_div_2( col1, col2, x1, y1, x2, y2 );
else {
   if( xw > yw ) {                                     /* split horz... */
       if( (bestxm-x1+1) * (y2-y1+1) < MIN_A ) {
           sub_div_2( col1, col2, x1, y1, x2, y2 );
           return(0);
           }
       if( abs( xm - l) > abs( xm - r) ) {
           show_add_box( col1, col2, x1, y1, bestxm, y2 );
           show_add_box( col1, col2, bestxm+1, y1, x2, y2 );
           }
       else {
           show_add_box( col1, col2, x1, y1, bestxm-1, y2 );
           show_add_box( col1, col2, bestxm, y1, x2, y2 );
           }
       }
   else {                                              /* split vert... */
       if( (bestym-y1+1) * (x2-x1+1) < MIN_A ) {
           sub_div_2( col1, col2, x1, y1, x2, y2 );
           return(0);
           }
       if( abs( ym - u) > abs( ym - d) ) {
           show_add_box( col1, col2, x1, y1, x2, bestym );
           show_add_box( col1, col2, x1, bestym+1, x2, y2 );
           }
       else {
           show_add_box( col1, col2, x1, y1, x2, bestym-1 );
           show_add_box( col1, col2, x1, bestym, x2, y2 );
           }
       }
   }
}



/************/
show_add_box( int col1, int col2, int x1, int y1, int x2, int y2 ) 
/************/
{
RECT       r;

/* show_box( col1, col2, x1, y1, x2, y2 );  */
show_box( 0, VERDE, x1, y1, x2, y2 );  

if( x2 - x1 >= img_size_x / 2 ) {
   beep();
   r.x1 = x1, r.y1 = y1, r.x2 = (x1+x2)/2, r.y2 = y2;
   lst = add_list_head( lst, &r );
   r.x1 = (x1+x2)/2+1, r.y1 = y1, r.x2 = x2, r.y2 = y2;
   lst = add_list_head( lst, &r );
   }
else if( y2 - y1 >= img_size_y / 2 ) {
   beep();
   r.x1 = x1, r.y1 = y1, r.x2 = x2, r.y2 = (y1+y2)/2;
   lst = add_list_head( lst, &r );
   r.x1 = x1, r.y1 = (y1+y2)/2+1, r.x2 = x2, r.y2 = y2;
   lst = add_list_head( lst, &r );
   }
else {
   r.x1 = x1, r.y1 = y1, r.x2 = x2, r.y2 = y2;
   lst = add_list_head( lst, &r );             /* metti "r" nella lista... */
   }
nbox++;
}



/************/
show_box( int col1, int col2, int x1, int y1, int x2, int y2 ) 
/************/
{

if( col1 > 0 ) {
   color( col1 ); 
   rectfi( x1*zoom, y1*zoom,  x1*zoom + (x2-x1+1)*zoom, y1*zoom + (y2-y1+1)*zoom );
   }
if( col2 > 0 ) {
   color( col2 ); 
   recti( x1*zoom, y1*zoom,  x1*zoom + (x2-x1+1)*zoom, y1*zoom + (y2-y1+1)*zoom );
   }
}



/************/
show_rect( int col, int x, int y ) 
/************/
{
color( col ); 
rectfi( x*zoom, y*zoom, (x+1)*zoom, (y+1)*zoom );
}



/************/
show_line( int colore, int x0, int x1, int y )
/************/
{
int    i;

for( i=x0;  i <= x1;  i++ )
   show_rect( colore,  i,  y );
}



#define    UL      (int )IMG(x-1, y-1)
#define    U       (int )IMG(x, y-1)
#define    UR      (int )IMG(x+1, y-1)
#define    L       (int )IMG(x-1, y)
#define    CC      (int )IMG(x-1, y)
#define    R       (int )IMG(x-1, y)
#define    DL      (int )IMG(x-1, y+1)
#define    D       (int )IMG(x, y+1)
#define    DR      (int )IMG(x+1, y+1)

/**************/
last_cerca_contorni() 
/**************/
{
int    x, y;

for( y=1;    y < img_size_y-1;    y++ )
   for( x=1;    x < img_size_x-1;    x++ )
       if( abs( 8*CC - UL - U - UR - L - R - DL - D - DR ) > par_cmp.soglia ) {
           IMG2( x, y ) = 1;
           show_rect( BLU, x, y );
           }
}


/**************/
Sobel_cerca_contorni() 
/**************/
{
int    x, y, p, q;

for( y=1;    y < img_size_y-1;    y++ )
   for( x=1;    x < img_size_x-1;    x++ ) {
       p = (UR + 2*R + DR) - (UL + 2*L + DL);
       q = (UL + 2*U + UR) - (DL + 2*D + DR);
       if( sqrt( (double )(p*p + q*q) ) > par_cmp.soglia ) {
           IMG2( x, y ) = 1;
           show_rect( BLU, x, y );
           }
       }
}




#define cond( dx, dy ) abs( IMG2( x, y ) - IMG2( x+dx, y+dy ))

/***********/
static pulizia_contorni( int ord )
/***********/
{
int    media, x, y;

if( ord < 1 )
   return( 0 );
ord--;

for( y=0, x=1;    x < img_size_x-1;    x++ )
   if( ( cond( 1, 0 ) + cond( 1, 1 ) + cond( 0, 1 ) +
         cond( -1, 0 ) + cond( -1, 1 ) )  >= (5-ord)  ) {
           media = IMG2( x+1, y ) + IMG2( x+1, y+1 ) + IMG2( x, y+1 ) + 
                   IMG2( x-1, y ) + IMG2( x-1, y+1 );
           IMG2( x, y ) = media / 5;
           /* show_rect( blimit( IMG2( x, y )), x, y ); */
           }
for( y=img_size_y-1, x=1;    x < img_size_x-1;    x++ )
   if( ( cond( 1, 0 ) + cond( 1, -1 ) + cond( 0, -1 ) +
         cond( -1, 0 ) + cond( -1, -1 ) )  >= (5-ord)  ) {
           media = IMG2( x+1, y ) + IMG2( x+1, y+1 ) + IMG2( x, y+1 ) + 
                   IMG2( x-1, y ) + IMG2( x-1, y+1 );
           IMG2( x, y ) = media / 5;
           /* show_rect( blimit( IMG2( x, y )), x, y ); */
           }
for( x=0, y=1;    y < img_size_y-1;    y++ )
   if( ( cond( 1, -1 ) + cond( 1, 0 ) + cond( 1, 1 ) +
         cond( 0, -1 ) + cond( 0, 1 ) )  >= (5-ord)  ) {
           media = IMG2( x+1, y-1 ) + IMG2( x+1, y ) + IMG2( x+1, y+1 ) +
                   IMG2( x, y-1 ) + IMG2( x, y+1 );
           IMG2( x, y ) = media / 5;
           /* show_rect( blimit( IMG2( x, y )), x, y ); */
           }
for( x=img_size_x-1, y=1;    y < img_size_y-1;    y++ )
   if( ( cond( 0, -1 ) + cond( 0, 1 ) + cond( -1, -1 ) + 
         cond( -1, 0 ) + cond( -1, 1 ) )  >= (5-ord)  ) {
           media = IMG2( x, y-1 ) + IMG2( x, y+1 ) + 
                   IMG2( x-1, y-1 ) + IMG2( x-1, y ) + IMG2( x-1, y+1 );
           IMG2( x, y ) = media / 5;
           /* show_rect( blimit( IMG2( x, y )), x, y ); */
           }

for( y=1;    y < img_size_y-1;    y++ )
   for( x=1;    x < img_size_x-1;    x++ )
       if( ( cond( 1, -1 ) + cond( 1, 0 ) + cond( 1, 1 ) +
           cond( 0, -1 ) + cond( 0, 1 ) +
           cond( -1, -1 ) + cond( -1, 0 ) + cond( -1, 1 ) )  >= (8-ord)  ) {
               media = IMG2( x+1, y-1 ) + IMG2( x+1, y ) + IMG2( x+1, y+1 ) +
                       IMG2( x, y-1 ) + IMG2( x, y+1 ) + 
                       IMG2( x-1, y-1 ) + IMG2( x-1, y ) + IMG2( x-1, y+1 );
               IMG2( x, y ) = media / 8;
               /* show_rect( blimit( IMG2( x, y )), x, y ); */
               }
}


